
<app-loader *ngIf="isLoad"></app-loader>

<div  *ngIf="!isEditBudgetLevels">
	<span [matTooltip]=" !checkAdd ?  'Добавление направлений подготовки невозможно' : null " >
		<button
			class="mb-16"
			mat-flat-button
			color="primary"
			[disabled]="!checkAdd"
			(click)="add()"> Добавить направление подготовки </button>
	</span>

	<div>
		<mat-form-field appearance="outline" fxFlex="">
			<input matInput type="text"
				[(ngModel)]="params.search_code_name"
				(ngModelChange)="searchText.next($event)"
				placeholder="Поиск по направлению подготовки"  >
			<button *ngIf="params.search_code_name" mat-icon-button matSuffix aria-label="Clear"
				(click)="params.search_code_name=''; searchText.next('') ">
				<mat-icon matSuffix svgIcon="close" ></mat-icon>
			</button>
		</mat-form-field>
	</div>


</div>


<div [hidden]="!finishFirstInit">

	<!--<pre> {{editingData | json}} </pre>

	<pre> {{admission[0]?.budget_o}} </pre>
	<pre> {{admission[1]?.budget_o}} </pre>-->

	<ng-container *ngIf="isEditBudgetLevels">
		<div class="mb-20">
			<button mat-button
				color="primary"
				(click)="goToAdmission()">
				<mat-icon svgIcon="chevron-left"></mat-icon>
				Вернуться к списку КЦП
			</button>
			<div class="ml-20">
				<h4> Уровни бюджетов </h4>
				<div> {{editingBudgetLevels[0].code_specialty}} {{editingBudgetLevels[0].name_specialty}} </div>
			</div>


		</div>

	</ng-container>


	<div class="art-card">
			<table mat-table
				[appStickyHeaderTable]="true"
				[dataSource]="dataSource"
				[multiTemplateDataRows]="true"
				class="">


				<ng-container  matColumnDef="education_level"  [sticky]="settings.stiky.education_level">
					<th mat-header-cell *matHeaderCellDef
						[attr.rowspan]="2" class="border-right"> Уровень образования </th>
					<td mat-cell *matCellDef="let item;let i = dataIndex"
						[attr.rowspan]="getRowSpan('education_level',i)"
						[style.display]="getRowSpan('education_level', i) ? '' : 'none'"
						class="border-right not-color"> {{item.name_education_level}} </td>
				</ng-container>

				<ng-container  matColumnDef="speciality"  [sticky]="settings.stiky.speciality">
					<th mat-header-cell *matHeaderCellDef [attr.rowspan]="2" class="border-right"> Направление подготовки </th>
					<td mat-cell *matCellDef="let item" class="border-right" >
						<div fxLayout="row" fxLayoutAlign="space-between center">
							<div>
								<!--<ng-container *ngIf="item.id" class="mr-4"> #{{ item.id  }} </ng-container>-->
								<span *ngIf="!isEditBudgetLevels" >{{item.name_specialty}}</span>
								<span *ngIf="isEditBudgetLevels" > {{item.name_level_budget || item.name_specialty}}</span>
							</div>
							<div *ngIf="item.has_distributed" >
								<mat-icon svgIcon="poll" class="ml-8" matTooltip="Указаны уровни бюджетов"></mat-icon>
							</div>
						</div>

					</td>
				</ng-container>

				<ng-container  matColumnDef="code_specialty" [sticky]="settings.stiky.code_specialty" >
					<th mat-header-cell *matHeaderCellDef [attr.rowspan]="2" class="border-right"> Код </th>
					<td mat-cell *matCellDef="let item" class="border-right">
						<span *ngIf="!isEditBudgetLevels ">{{item.code_specialty}}</span>
						<span *ngIf="isEditBudgetLevels && !isBudgetLevel(item)">
						{{ item.code_specialty }}
					 </span>
					</td>
				</ng-container>

				<ng-container matColumnDef="budget" >
					<th mat-header-cell *matHeaderCellDef
						[attr.colspan]="3" class="border-right"> Общий конкурс</th>
				</ng-container>

				<ng-container  matColumnDef="budget_o"  >
					<th mat-header-cell *matHeaderCellDef> Очное </th>
					<td mat-cell *matCellDef="let item;"  >
						<span *ngIf="!idEditing(item.id)">{{item.budget_o}} </span>
						<mat-form-field class="xs-input" *ngIf="idEditing(item.id)">
							<input matInput appInteger maxlength="7" min="0"
								[(ngModel)]="editingData.budget_o" required>
						</mat-form-field>
					</td>
				</ng-container>

				<ng-container  matColumnDef="budget_oz"  >
					<th mat-header-cell *matHeaderCellDef> Очно-заочное</th>
					<td mat-cell *matCellDef="let item" >
						<span *ngIf="!idEditing(item.id)">{{item.budget_oz}} </span>
						<mat-form-field class="xs-input" *ngIf="idEditing(item.id)">
							<input matInput appInteger maxlength="7" min="0"
								[(ngModel)]="editingData.budget_oz" required>
						</mat-form-field>
					</td>
				</ng-container>

				<ng-container  matColumnDef="budget_z"  >
					<th mat-header-cell *matHeaderCellDef class="border-right"> Заочное </th>
					<td mat-cell *matCellDef="let item" class="border-right">
						<span *ngIf="!idEditing(item.id)">{{item.budget_z}} </span>
						<mat-form-field class="xs-input" *ngIf="idEditing(item.id)">
							<input matInput appInteger maxlength="7" min="0"
								[(ngModel)]="editingData.budget_z" required>
						</mat-form-field>
					</td>
				</ng-container>

				<ng-container matColumnDef="quota" >
					<th mat-header-cell *matHeaderCellDef  [attr.colspan]="3" class="border-right" > Особая квота </th>
				</ng-container>

				<ng-container  matColumnDef="quota_o"  >
					<th mat-header-cell *matHeaderCellDef > Очное </th>
					<td mat-cell *matCellDef="let item" >
						<span *ngIf="!idEditing(item.id)">{{item.quota_o}} </span>
						<mat-form-field class="xs-input"  *ngIf="idEditing(item.id)">
							<input matInput appInteger maxlength="7" min="0"
								[(ngModel)]="editingData.quota_o" required>
						</mat-form-field>
					</td>
				</ng-container>

				<ng-container  matColumnDef="quota_oz"  >
					<th mat-header-cell *matHeaderCellDef> Очно-заочное </th>
					<td mat-cell *matCellDef="let item" >
						<span *ngIf="!idEditing(item.id)">{{item.quota_oz}} </span>
						<mat-form-field class="xs-input" *ngIf="idEditing(item.id)">
							<input matInput appInteger maxlength="7" min="0"
								[(ngModel)]="editingData.quota_oz" required>
						</mat-form-field>
					</td>
				</ng-container>

				<ng-container  matColumnDef="quota_z"  >
					<th mat-header-cell *matHeaderCellDef class="border-right"> Заочное </th>
					<td mat-cell *matCellDef="let item" class="border-right" >
						<span *ngIf="!idEditing(item.id)">{{item.quota_z}} </span>
						<mat-form-field class="xs-input" *ngIf="idEditing(item.id)">
							<input matInput appInteger maxlength="7" min="0"
								[(ngModel)]="editingData.quota_z" required>
						</mat-form-field>
					</td>
				</ng-container>

				<ng-container matColumnDef="sum" [stickyEnd]="settings.stiky.sum">
					<th mat-header-cell *matHeaderCellDef [attr.colspan]="2" class="border-right light-col"> КЦП  </th>
				</ng-container>
				<ng-container  matColumnDef="sum_available" [stickyEnd]="settings.stiky.sum" >
					<th mat-header-cell *matHeaderCellDef class="light-col"> Доступно </th>
					<td mat-cell *matCellDef="let item" class="light-col">
					<span *ngIf="item.id">
						{{item | sumByKeys: sumKeys}}
					</span>
					</td>
				</ng-container>

				<ng-container  matColumnDef="sum_distributed" [stickyEnd]="settings.stiky.sum">
					<th mat-header-cell *matHeaderCellDef class="border-right light-col">
						Распределено <br>
						(к.г./у.б.)
					</th>
					<td mat-cell *matCellDef="let item" class="border-right light-col" >
					<span *ngIf="item.id">
						<span class="highlight" matTooltip="Распределено по конкурсным группам">
							{{item?.sum_competitive}}
						</span>

						<span *ngIf="item.sum_distributed"> /
							<span class="highlight" matTooltip="Распределено по уровням бюджетов">
								{{item?.sum_distributed}}
							</span>
						</span>
					</span>
					</td>
				</ng-container>


				<ng-container matColumnDef="paid" >
					<th mat-header-cell *matHeaderCellDef  [colSpan]="3" class="border-right"> Платный прием  </th>
				</ng-container>

				<ng-container  matColumnDef="paid_o"  >
					<th mat-header-cell *matHeaderCellDef > Очное </th>
					<td mat-cell *matCellDef="let item" >
						<span *ngIf="!idEditing(item.id)">{{item?.paid_o}} </span>
						<mat-form-field class="xs-input" *ngIf="idEditing(item.id) && !isBudgetLevel(item)">
							<input matInput appInteger maxlength="7" min="0"
								[(ngModel)]="editingData.paid_o" required>
						</mat-form-field>
					</td>
				</ng-container>

				<ng-container  matColumnDef="paid_oz"  >
					<th mat-header-cell *matHeaderCellDef> Очно-заочное </th>
					<td mat-cell *matCellDef="let item" >
						<span *ngIf="!idEditing(item.id)">{{item?.paid_oz}} </span>
						<mat-form-field class="xs-input" *ngIf="idEditing(item.id) && !isBudgetLevel(item)">
							<input matInput appInteger maxlength="7" min="0"
								[(ngModel)]="editingData.paid_oz" required>
						</mat-form-field>
					</td>
				</ng-container>

				<ng-container  matColumnDef="paid_z"  >
					<th mat-header-cell *matHeaderCellDef class="border-right"> Заочное </th>
					<td mat-cell *matCellDef="let item" class="border-right">
						<span *ngIf="!idEditing(item.id)">{{item?.paid_z}} </span>
						<mat-form-field class="xs-input" *ngIf="idEditing(item.id) && !isBudgetLevel(item)">
							<input matInput appInteger maxlength="7" min="0"
								[(ngModel)]="editingData.paid_z" required>
						</mat-form-field>
					</td>
				</ng-container>

				<ng-container matColumnDef="target" >
					<th mat-header-cell *matHeaderCellDef  [colSpan]="3" class="border-right"> Целевая квота </th>
				</ng-container>

				<ng-container  matColumnDef="target_o"  >
					<th mat-header-cell *matHeaderCellDef> Очное </th>
					<td mat-cell *matCellDef="let item"  >
						<span *ngIf="!idEditing(item.id)">{{item.target_o}} </span>
						<mat-form-field class="xs-input" *ngIf="idEditing(item.id)">
							<input matInput appInteger maxlength="7" min="0"
								[(ngModel)]="editingData.target_o" required>
						</mat-form-field>
					</td>
				</ng-container>

				<ng-container  matColumnDef="target_oz"  >
					<th mat-header-cell *matHeaderCellDef> Очно-заочное </th>
					<td mat-cell *matCellDef="let item" >
						<span *ngIf="!idEditing(item.id)">{{item.target_oz}} </span>
						<mat-form-field class="xs-input" *ngIf="idEditing(item.id)">
							<input matInput appInteger maxlength="7" min="0"
								[(ngModel)]="editingData.target_oz" required>
						</mat-form-field>
					</td>
				</ng-container>

				<ng-container  matColumnDef="target_z" class="border-right" >
					<th mat-header-cell *matHeaderCellDef class="border-right"> Заочное </th>
					<td mat-cell *matCellDef="let item" class="border-right">
						<span *ngIf="!idEditing(item.id)">{{item.target_z}} </span>
						<mat-form-field class="xs-input" *ngIf="idEditing(item.id)">
							<input matInput appInteger maxlength="7" min="0"
								[(ngModel)]="editingData.target_z" required>
						</mat-form-field>
					</td>
				</ng-container>

				<ng-container matColumnDef="uid">
					<th mat-header-cell *matHeaderCellDef [rowSpan]="2"  class="border-right"> UID </th>
					<td mat-cell *matCellDef="let item; let index = dataIndex;" class="border-right" >
						<span *ngIf="!idEditing(item.id)">{{item.uid}}</span>
						<mat-form-field class="m-input" *ngIf="idEditing(item.id)">
							<input matInput appNullValue maxlength="36"
								[(ngModel)]="editingData.uid">
						</mat-form-field>
					</td>
				</ng-container>




				<ng-container matColumnDef="action" [stickyEnd]="settings.stiky.actions">
					<th mat-header-cell *matHeaderCellDef class="border-left" >
						<button mat-icon-button
							(click)="tableSetting()"
							matTooltip="Настроить отображение таблицы">
							<mat-icon svgIcon="cog"></mat-icon>
						</button>
					</th>
					<td mat-cell *matCellDef="let item; let index = dataIndex;" class="border-left">
					<span *ngIf="item.id">
						<button mat-icon-button
							*ngIf="!editingId"
							[matMenuTriggerFor]="menu">
						  <mat-icon svgIcon="dots-vertical"> </mat-icon>
						</button>

						<mat-menu #menu="matMenu"  >
							<ng-container *ngIf="!isBudgetLevel(item); else budgetMenu">
								<span [matTooltip]=" checkEditRemove ? null : 'Редактирование недоступно'">
									<button mat-menu-item
										[disabled]="!checkEditRemove"
										(click)="edit(item.id, index)">
										<mat-icon svgIcon="pencil"></mat-icon>
										<span >Изменить данные</span>
								    </button>
								</span>
								<button mat-menu-item
									(click)="editUidAdmissionVolume(item, index)">
									<mat-icon svgIcon="pencil"></mat-icon>
									<span>Изменить uid</span>
						        </button>

								<span [matTooltip]=" checkEditRemove ? null : 'Удаление недоступно'">
									<button mat-menu-item
										[disabled]="!checkEditRemove"
										(click)="deleteAdmission(item, index)">
										<mat-icon svgIcon="delete"></mat-icon>
										<span>Удалить</span>
									 </button>
								</span>

								<span [matTooltip]=" checkEditRemove ? null : 'Добавление уровней бюджета недоступно'">
									<button mat-menu-item
										[disabled]="!checkEditRemove"
										*ngIf="!editingBudgetLevels"
										(click)="addBudgetLevels(item)">
										<mat-icon svgIcon="plus"></mat-icon>
										<span>Добавить уровни бюджета</span>
								    </button>
								</span>
								<button mat-menu-item *ngIf='item.has_distributed && !editingBudgetLevels'
									(click)="editBudgetLevels(item.id)">
									<mat-icon svgIcon="eye"></mat-icon>
									<span>Посмотреть уровни бюджета</span>
								 </button>
							</ng-container>

							<ng-template #budgetMenu>
								<span [matTooltip]=" checkEditRemove ? null : 'Редактирование недоступно'">
									<button mat-menu-item
										[disabled]="!checkEditRemove"
										(click)="edit(item.id, index)">
										<mat-icon svgIcon="pencil"></mat-icon>
										<span>Изменить данные</span>
							        </button>
								</span>
								<button mat-menu-item
									(click)="editUidBudget(item, index)">
									<mat-icon svgIcon="pencil"></mat-icon>
									<span>Изменить uid</span>
						        </button>
								<span [matTooltip]=" checkEditRemove ? null : 'Удаление недоступно'">
									<button mat-menu-item
										[disabled]="!checkEditRemove"
										(click)="deleteBudgetLevel(item)">
										<mat-icon svgIcon="delete"></mat-icon>
										<span>Удалить уровень бюджета</span>
								    </button>
								</span>
							</ng-template>
						</mat-menu>

						<span [matTooltip]=" checkEditRemove ? null : 'Редактирование недоступно'">
							<button mat-icon-button [disabled]="!checkEditRemove"
								*ngIf="idEditing(item.id)"
								[matMenuTriggerFor]="menuEditing" aria-label="icon-button with a menu">
						        <mat-icon svgIcon="dots-vertical"> </mat-icon>
							</button>
						</span>


						<mat-menu #menuEditing="matMenu">
							<ng-container *ngIf="!isBudgetLevel(item); else budgetEditing" >
								<button mat-menu-item (click)="save(index)">
								<mat-icon svgIcon="content-save-outline"></mat-icon>
								<span>Сохранить данные</span>
						    </button>
							<button mat-menu-item (click)="cancelEdit()">
								<mat-icon svgIcon="undo"></mat-icon>
								<span>Отменить изменения</span>
							</button>
							</ng-container>
							<ng-template #budgetEditing>
								<button mat-menu-item (click)="saveBudget(index)">
									<mat-icon svgIcon="content-save-outline"></mat-icon>
									<span>Сохранить данные бюджета</span>
							    </button>
								<button mat-menu-item (click)="cancelEdit()">
									<mat-icon svgIcon="undo"></mat-icon>
									<span>Отменить изменения</span>
								</button>
							</ng-template>
						</mat-menu>


					</span>
					</td>
				</ng-container>

				<ng-container matColumnDef="action-two" [stickyEnd]="settings.stiky.actions">
					<th mat-header-cell *matHeaderCellDef class="border-left" >
					</th>
				</ng-container>

				<ng-container matColumnDef="noRecord">
					<td mat-footer-cell *matFooterCellDef [colSpan]="displayedColumns.length" ><i>КЦП не найдены</i></td>
				</ng-container>



				<tr mat-header-row *matHeaderRowDef="displayedHeaderColumns; sticky: true"></tr>

				<tr mat-header-row *matHeaderRowDef="displayedHeaderTwoColumns; sticky: true"></tr>

				<tr class="table-row-admission" [ngClass]="{ 'group': !item.id }" mat-row *matRowDef="let item; columns: displayedColumns"></tr>

				<tr mat-footer-row *matFooterRowDef="['noRecord'] " [hidden]="dataSource.length !== 0"></tr>



			</table>
			<mat-paginator
				[length]="total"
				[pageIndex]="params.page - 1"
				[pageSize]="params.limit"
				(page)="pagination.next($event)"
				[pageSizeOptions]="[5, 10, 15, 20, 30, 50]"
				[disabled]="editingId || isEditBudgetLevels"
				showFirstLastButtons>
			</mat-paginator>
		</div>







</div>

